<?php

// ----------------------------
// MyPower.CZ Microlog Protocol
// http://microlog.mypower.cz

$_microlog_storage_dir       = "/tmp/microlog";

$_microlog_true_values       = "yes";     // yes / no

$_microlog_failover_buffer   = "yes";     // yes / no

// ----------------------------------------------

$modMyPowerHost              = "log.mypower.cz";

// ----------------------------------------------
function Microlog_SendDataToMyPower($fveid,$pinconfig,$data)
{
global $_microlog_failover_buffer,$modMyPowerHost;
$xret=array();
if ($_microlog_failover_buffer=="yes")
  {
  $xtime=time();
  $nosend=false;
  while ($bufferdata=Microlog_Buffer_GetData())
    {
    $xret=Microlog_SendDataToMyPower_int($bufferdata);
    if ( ($xret["finalresult"]!="OK") and
         (isset($xret["bufhostchanged"])) and
         ($xret["bufhostchanged"]=="yes") )
      {
      echo "Retrying host: ".$modMyPowerHost."\n";
      unset($bufferdata["httpsenddata"]);
      $xret=Microlog_SendDataToMyPower_int($bufferdata);
      }

    if ($xret["finalresult"]=="OK")
      Microlog_Buffer_DeleteData($bufferdata);
    else
      {
      Microlog_Buffer_StoreData($fveid,$pinconfig,$data,$xtime,false);
      $xret=array("message"=>"failover buffer: ".$xtime.".json ".
        "(".date("Y-m-d H:i:s",$xtime).")");
      $nosend=true;
      break;
      }
    }
  if (!$nosend)
    {
    $xret=Microlog_SendDataToMyPower_int($fveid,$pinconfig,$data,$xtime);
    if ($xret["finalresult"]!="OK")
      {
      Microlog_Buffer_StoreData($fveid,$pinconfig,$data,$xtime,$xret);
      $xret=array("message"=>"failover buffer: ".$xtime.".json".
        "(".date("Y-m-d H:i:s",$xtime).")");
      }
    }
  }
else
  {
  $xret=Microlog_SendDataToMyPower_int($fveid,$pinconfig,$data,time());
  }
return $xret;
}

// ----------------------------------------------
function Microlog_SendDataToMyPower_int($fveid,$pinconfig=false,$data=false,$xtime=false)
{
global $_microlog_true_values, $modMyPowerHost;

$MPWMicroLogVersion="2.04.php";

$buffered_httpsenddata="";
$buffered_host="";
if (is_array($fveid))
  {
  $bufferdata=$fveid;
  $fveid=$bufferdata["fveid"];
  $pinconfig=$bufferdata["pinconfig"];
  $data=$bufferdata["data"];
  $xtime=$bufferdata["xtime"];
  $buffered_httpsenddata=isset($bufferdata["httpsenddata"])?$bufferdata["httpsenddata"]:"";
  if ( (count($cx=explode("Host: ",$buffered_httpsenddata))>=2) and
       (count($ch=explode("\r\n",$cx[1]))>=2) )
    $buffered_host=trim($ch[0]);
  echo "Using buffered data.\n";
  }

$isdebug=false;
$xresult=array();
if ($buffered_httpsenddata=="")
  echo "Host: ".$modMyPowerHost."\n";
else
  {
  echo "Buffered host: ".$buffered_host."\n";
  if ($buffered_host!=$modMyPowerHost)
    {
    echo "! Config host: ".$modMyPowerHost."\n";
    $xresult["bufhostchanged"]="yes";
    }
  }
$islogin=Microlog_CheckPinConfigChange($pinconfig);
if ($islogin) echo "login\n";
$millis=0;
if ( (file_exists($ufile="/proc/uptime")) and
     (count($tt=explode(" ",@file_get_contents($ufile)))==2) and
     ((($xm=((float)array_shift($tt))*1000))>0) )
  $millis=$xm;
else
  $millis=round((microtime(true)-mktime(0, 0, 0, 1, 1, 2019))*1000);

$lxSeconds=floor($millis/1000);
$millis=$millis & 0xFFFFFFFF;

$httpsenddata=sprintf(
  "GET / HTTP/1.0\r\n".
  "Host: %s\r\n".
  "User-Agent: MPWmicrolog/%s\r\n".
  "Cookie: fveid=%s; ",
    $modMyPowerHost,
    $MPWMicroLogVersion,
    $fveid);

if ($islogin)
  {
  $httpsenddata.="cdate=".date("M_d_Y_H:i:s",filemtime(__FILE__))."; ";
  $httpsenddata.="login=yes; ";
  }

$httpsenddata.="utime=".((int)$millis)."/".((int)$lxSeconds)."; ";
$httpsenddata.="AX=VSAMX; ";

$httpsenddata.="xtime=".$xtime."; ";

$optdefs=Microlog_GetOptDefs();

for ($xp=0;$xp<16;$xp++)
  {

  if ($isvalid=(isset($pinconfig["A".$xp]) and is_array($pconf=$pinconfig["A".$xp])))
    {

    if ($islogin)
      {
      $vmin10k=(isset($pconf["min"])?(float)$pconf["min"]:0);
      $vmax10k=(isset($pconf["max"])?(float)$pconf["max"]:0);
      $smin10k=sprintf("%ld.%04d",$vmin10k,(abs($vmin10k)*10000)%10000);
      $smax10k=sprintf("%ld.%04d",$vmax10k,(abs($vmax10k)*10000)%10000);
      $pinopt=0;
      if ( (isset($pconf["opt"])) and (is_array($px=$pconf["opt"])) )
        {
        reset($px);
        while ($cc=each($px))
          {
          $cv=$cc["value"];
          reset($optdefs);
          while ($cc=each($optdefs))
            {
            list($xmask,$xopts)=$cc["value"];
            if ( (is_array($xopts)) and (isset($xopts[$cv])) )
              $pinopt=(($pinopt)|($xopts[$cv]&$xmask));
            }

          }
        }
//      var_dump(decbin($pinopt));
      $httpsenddata.=sprintf("AC%d=%X/%s/%s/",$xp,$pinopt,$smin10k,$smax10k);
      $xf="%02X";
      $xh="";
      $pinname=isset($pconf["name"])?(string)$pconf["name"]:"";
      for ($i=0;$i<strlen($pinname);$i++) { $httpsenddata.=sprintf("%02X",ord($pinname[$i])); }
      $httpsenddata.="/";
      $unitname=isset($pconf["unit"])?(string)$pconf["unit"]:"";
      for ($i=0;$i<strlen($unitname);$i++) { $httpsenddata.=sprintf("%02X",ord($unitname[$i])); }
      $httpsenddata.="; ";
      }

    if (isset($data["A".$xp]))
      {
      list($smpVal,$smpSqr,$smpAvg,$smpMin,$smpMax)=Microlog_GetPinValues($xp,$pinconfig,$data);
      $httpsenddata.=sprintf(
        "A%d=%X,%X,%X,%X,%X; ",
          $xp, $smpVal, $smpSqr, $smpAvg, $smpMin, $smpMax);

      if ($_microlog_true_values=="yes")
        {
        list($smpVal,$smpSqr,$smpAvg,$smpMin,$smpMax)=Microlog_GetPinValues($xp,$pinconfig,$data,true);
        $httpsenddata.=sprintf(
          "AT%d=%s/%s/%s/%s/%s; ",
            $xp, $smpVal, $smpSqr, $smpAvg, $smpMin, $smpMax);
        }

      }

    }
  }

//$xMpwAccess["xComStatus"]=$xMpwAccess["xComStatus"] & ~$xComStatusASchanged;
$httpsenddata.="\r\n\r\n";

$xresult["httpsenddata"]=$httpsenddata;

$errno=0;
$errstr="";

$httpreply="";

$fp = @fsockopen($modMyPowerHost, 80, $errno, $errstr, 10);
if (!$fp)
  echo $errstr." (".$errno.")\n";
else
  {
  $outdata=( ($buffered_httpsenddata=="") ? ($httpsenddata) : ($buffered_httpsenddata) );
  fwrite($fp, $outdata );
  while ( (!feof($fp)) and (strlen($httpreply)<1024) )
    $httpreply.=fgets($fp,1024);
  fclose($fp);
  }

$mheaders="";

$xreply=explode("\r\n\r\n",$httpreply);
if (count($xreply)>1)
  $mheaders=array_shift($xreply);

$mreply=implode("\r\n\r\n",$xreply);

if ($isdebug)
  $xresult["headers"]=$mheaders;

$xresult["message"]="";

$rdata=array();
$lines=explode("\n",$mreply);
reset($lines);
while($cc=each($lines))
  if ( (count($rline=explode(":",$xline=trim($cc["value"])))>1) and
       ( ($rkey=array_shift($rline))!="" ) and
       (in_array($rkey,array("server","fveid","time","result","qid"))) )
    {
    $rval=implode(":",$rline);
    $rdata[$rkey]=$rval;
    }
  else
  if ($xline!="")
    $xresult["message"].=$xline."\n";


$xresult["data"]=$rdata;
if (($xresult["message"]=trim($xresult["message"]))=="")
  unset($xresult["message"]);

$xresult["finalresult"] = isset($rdata["result"]) ? $rdata["result"] : "n/a";

return $xresult;
}

// ----------------------------------------------
function Microlog_GetOptDefs()
{
return array(
   "enabled" =>[     0b00000001,array(
      "disabled"  => 0b00000000,
      "enabled"   => 0b00000001,
      )],

   "type"    =>[     0b01110000,array(
      "smp"       => 0b00000000,
      "avg"       => 0b00010000,
      "rms"       => 0b00100000,
      "min"       => 0b00110000,
      "max"       => 0b01000000,
      "res1"      => 0b01010000,
      "res2"      => 0b01100000,
      "def"       => 0b01110000,
      )],

   "group"   =>[     0b00001100,array(
      "group0"    => 0b00000000,
      "group1"    => 0b00000100,
      "group2"    => 0b00001000,
      "group3"    => 0b00001100,
      )],
   );
}


// ----------------------------------------------
function Microlog_GetPinValues($xp,&$pinconfig,&$data,$wanttrue=false)
{
$smpVal=0;
$smpSqr=0;
$smpAvg=0;
$smpMin=0;
$smpMax=0;
if ( (isset($pinconfig["A".$xp])) and (is_array($pconf=$pinconfig["A".$xp])) and
     (isset($data["A".$xp])) )
  {
  if (is_array($xdata=$data["A".$xp]))
    {
    $smpVal=isset($xdata[$k="smp"])?(float)$xdata[$k]:$smpVal;
    $smpSqr=isset($xdata[$k="rms"])?(float)$xdata[$k]:$smpSqr;
    $smpAvg=isset($xdata[$k="avg"])?(float)$xdata[$k]:$smpAvg;
    $smpMin=isset($xdata[$k="min"])?(float)$xdata[$k]:$smpMin;
    $smpMax=isset($xdata[$k="max"])?(float)$xdata[$k]:$smpMax;
    }
  else
    $smpMax=$smpMin=$smpAvg=$smpSqr=$smpVal=(float)$xdata;

  if (!$wanttrue)
    {
    $smpVal=Microlog_RecalcValueTo10bit($smpVal,$pconf);
    $smpSqr=Microlog_RecalcValueTo10bit($smpSqr,$pconf);
    $smpAvg=Microlog_RecalcValueTo10bit($smpAvg,$pconf);
    $smpMin=Microlog_RecalcValueTo10bit($smpMin,$pconf);
    $smpMax=Microlog_RecalcValueTo10bit($smpMax,$pconf);
    }
  else
    {
    $smpVal=trim($smpVal);
    $smpSqr=trim($smpSqr);
    $smpAvg=trim($smpAvg);
    $smpMin=trim($smpMin);
    $smpMax=trim($smpMax);
    }
  }
return array($smpVal,$smpSqr,$smpAvg,$smpMin,$smpMax);
}

// ----------------------------------------------
function Microlog_RecalcValueTo10bit($smpVar,$pconf)
{
if ( (is_array($pconf)) and (isset($pconf["min"])) and (isset($pconf["max"])) )
  {
  $xdif= ($xmax=(float)$pconf["max"]) - ($xmin=(float)$pconf["min"]);
  $smpVar = (int) round(1023 * ( $smpVar - $xmin ) / $xdif);
  if ($smpVar>1023) $smpVar=1023; else if ($smpVar<0) $smpVar=0;
  }
return $smpVar;
}

// ----------------------------------------------
function Microlog_GetStorageDir()
{
global $_microlog_storage_dir;
$xret=false;
if ( (isset($_microlog_storage_dir)) and (trim($_microlog_storage_dir)!="") )
  {
  if ( (!is_dir($_microlog_storage_dir)) and (!mkdir($_microlog_storage_dir)) )
    echo "Nelze vytvorit ".$_microlog_storage_dir."\n";
  else
  if (!is_dir($_microlog_storage_dir))
    echo "Nelze najit ".$_microlog_storage_dir."\n";
  else
    $xret=$_microlog_storage_dir;
  }
return $xret;
}

// ----------------------------------------------
function Microlog_CheckPinConfigChange($pinconfig)
{
$xret=false;
$tsha=sha1(json_encode(array($pinconfig,date("M_d_Y_H:i:s",filemtime(__FILE__)))));
if ($ddir=Microlog_GetStorageDir())
  {
  $dconfshafile=$ddir."/~pinconfsha";
  $oldsha= is_file($dconfshafile) ? @file_get_contents($dconfshafile) : "";
  if ($xret=($oldsha!=$tsha))
    if (!file_put_contents($dconfshafile,$tsha))
      echo "Nelze zapsat do ".$dconfshafile."\n";
  }
return $xret;
}

// ----------------------------------------------
function Microlog_Buffer_GetData()
{
$xret=false;
if ($bdir=Microlog_Buffer_GetStorageDir())
  {
  $qdir=getcwd();
  chdir($bdir);
  $q=glob("*.json");
  chdir($qdir);
  if (count($q)>0)
    {
    echo "Buffer items: ".count($q)."\n";
    sort($q);
    $xfile=$bdir."/".array_shift($q);
    if ( (is_file($xfile)) and
         (is_array($xdata=@json_decode(@file_get_contents($xfile),true))) )
      {
      $xret=$xdata;
      echo "To send: ".date("Y-m-d H:i:s",$xret["xtime"])."\n";
      }
    }
  }
return $xret;
}

// ----------------------------------------------
function Microlog_Buffer_DeleteData($bufferdata)
{
if ( (is_array($bufferdata)) and
     ($bdir=Microlog_Buffer_GetStorageDir()) and
     (isset($bufferdata["xtime"])) and
     (is_file($bfile=$bdir."/".$bufferdata["xtime"].".json")) )
  {
  if (unlink($bfile))
    echo "Deleted: ".basename($bfile)."\n";
  }
else
  {
  die("Nelze smazat data v bufferu.\n");
  }

}

// ----------------------------------------------
function Microlog_Buffer_StoreData($fveid,$pinconfig,$data,$xtime,$xret)
{
$bufferdata=array(
  "fveid"=>$fveid,
  "pinconfig"=>$pinconfig,
  "data"=>$data,
  "xtime"=>$xtime,
  );
if ( (is_array($xret)) and (isset($xret["httpsenddata"])) )
  $bufferdata["httpsenddata"]=$xret["httpsenddata"];
if ($bdir=Microlog_Buffer_GetStorageDir())
  {
  $fname=$bdir."/".(int)$xtime.".json";
  if (!is_file($fname))
    if (!file_put_contents($fname,json_encode($bufferdata)))
      echo "Nemohu ulozit data do ".$fname.".\n";
  }
}

// ----------------------------------------------
function Microlog_Buffer_GetStorageDir()
{
global $_microlog_storage_dir;
$xret=false;
if ($sdir=Microlog_GetStorageDir())
  {
  $mdir=$sdir."/buffer";
  if ( (!is_dir($mdir)) and (!mkdir($mdir)) )
    echo "Nelze vytvorit ".$mdir."\n";
  else
    $xret=$mdir;
  }
return $xret;
}

// ----------------------------------------------
function Microlog_CheckDataInArgs($args)
{
$xdata=false;
if (is_array($args))
  {
  reset($args);
  while ($cc=each($args))
    {
    $carg=$cc["value"];
    if ( ($carg=="-data") and ($cc=each($args)) and
         (($cdata=$cc["value"])!="") )
      {
      $xdata=array();
      echo "DATA:\n";
      $dd=explode(",",$cdata);
      while ($cc=each($dd))
        if ( (count($tt=explode(":",trim($cc["value"])))==2) and
             ($tpin=array_shift($tt)) and
             (substr($tpin,0,1)=="A") and
             ( ( $pinnumber=abs((int)substr($tpin,1)) ) < 16) )
          {
          $tval=(float)array_shift($tt);
          $xdata[$rpin="A".$pinnumber]=$tval;
          echo "  ".$rpin." ".($pinnumber<10?" ":"").": ".$tval."\n";
          }
      }
    }
  }
return $xdata;
}

?>