<?php

// ----------------------------
// MyPower.CZ Microlog Protocol
// http://microlog.mypower.cz

// --- COMMANDLINE ONLY -------------------------------

if ( (isset($_SERVER["SERVER_SOFTWARE"])) or
     (isset($_SERVER["REMOTE_ADDR"])) ) die();

// --- INCLUDE ----------------------------------------

include("lib-mpw-microlog.php");

// --- CONFIG -----------------------------------------

$pinconfig=array(
  "A0"  => array (
     "name" => "Panely FV1",
     "unit" => "V",
     "min"  => 0,
     "max"  => 150,
     "opt"  => ["enabled","smp","group0"],
     ),
// ...
  "A6"  => array (
     "name" => "Proud AC L1",
     "unit" => "A",
     "min"  => 0,
     "max"  => 32,
     "opt"  => ["enabled","rms","group2"],
     ),
// ...
  "A11"  => array (
     "name" => "Digital 10 bitx",
     "unit" => "#",
     "min"  => 0,
     "max"  => 1023,
     "opt"  => ["enabled","res1","group3"],
     ),
// ...
  "A15"  => array (
     "name" => "Centrála výkon",
     "unit" => "W",
     "min"  => 0,
     "max"  => 5000,
     "opt"  => ["enabled","avg","group3"],
     ),
  );

// ENABLED: enabled, disabled
//    TYPE: sample, avg, effective, min, max, res1, res2, default
//   GROUP: group0, group1, group2, group3
// --------------------------------------------------------------


// --- DATA -------------------------------------------

if (!is_array($data=Microlog_CheckDataInArgs($_SERVER["argv"])))
  {

  $data=array(

    "A0"  =>  25.722322566,

    "A6"  =>  array(
      "smp"  =>  2.2116,
      "rms"  =>  6.52,
      "avg"  =>  5.321,
      "min"  =>  0,
      "max"  =>  7.1235,
      ),

  //  "A11" =>  (0b1011001110),
  //  "A11" =>  0x3ff,
    "A11" =>  1023,

    "A15" =>  955055732.54321,

    );
  }

// --- FVEID ------------------------------------------

$fveid="mojefve123456";

// --- POST DATA --------------------------------------

$result=Microlog_SendDataToMyPower($fveid,$pinconfig,$data);

// --- RESULT -----------------------------------------

if (is_array($result))
  {

  if (isset($result["message"]))
    echo $result["message"]."\n";
  else
  if (isset($result["data"]))
    {

    if (isset($result["data"]["result"]))
      {

      if ($result["data"]["result"]=="OK")
        echo "ok\n";
      else
        echo $result["data"]["result"];

      }

    if (isset($result["data"]["qid"]))
      echo "QID: ".$result["data"]["qid"]."\n";

    }

  }

?>